﻿'
' Modbus RTU VB.NET sample for IR API Library.
' This demo application Is a Visual Studi 2019 VB WPF project for IR-210/IR-712A.
' 
' IR API WPF VB Sample
' 
' Release Note
'   [v2.2.0.0], 2022-June-02
'

Imports System.Text
Imports System.Threading

Public Class IRMBRTUDemoVBWin0

    Dim _comPortNo As Byte = 6          ' COM port number
    Dim _baudRate As UInt32 = 115200    ' baud rate (bps)
    Dim _baudRateIndex As Byte = 10     ' baudrate index [6] ~ [10]
    Dim _databits As Byte = 8           ' data bits
    Dim _parity As Byte = 0             ' parity
    Dim _stopbitsIndex As Byte = 0      ' stopbits index 0: databits == 1, 2: databits == 2
    Dim _mbID As Byte = 1               ' Modbus Net ID

    Dim IROutputChArr As Byte() = New Byte(6) {&H1, &H2, &H4, &H8, &H10, &H20, &H3F} ' (7 elements)Combinations Of IR output channels.
    Dim deviceNameArr(10) As String    ' Strings array(11 elements) For IR device names.
    Dim cmdNameArr(511) As String      ' 512 elements 

    Dim irCmdQtyInDevice As Int32() = New Int32(2) {1, 2, 3}
    Dim IrDeviceTotalQty As Int32 = 3
    Dim IrCmdCurrTotalCmd As Int32 = 6

    Dim IrCmdSummaryArr(12) As Int32   '

    Dim thDwLDIR    ' Thread For downloading IR cmds To the IR Module And updating IR cmd numbers In the Textbox "txtIRCmdQtyCurr".
    Dim thLDIR      ' Thread For loading IR cmds from the IR Module And updating IR cmd numbers In the Textbox "txtIRCmdQtyCurr".
    Dim ii          ' for loop index



    Private Sub Window_Loaded(sender As Object, e As RoutedEventArgs)
        Me.Height = 600

        'Com port combobox
        cboCOMPort.Items.Clear()
        For i As Integer = 0 To 31
            cboCOMPort.Items.Add("COM" + (i + 1).ToString())
        Next i
        cboCOMPort.SelectedIndex = 4

        'Baud rate combobox
        cboBaudRate.Items.Clear()
        cboBaudRate.Items.Add("9600")
        cboBaudRate.Items.Add("19200")
        cboBaudRate.Items.Add("38400")
        cboBaudRate.Items.Add("57600")
        cboBaudRate.Items.Add("115200")
        cboBaudRate.SelectedIndex = 4

        cboBaudRate_GS.Items.Add("9600")
        cboBaudRate_GS.Items.Add("19200")
        cboBaudRate_GS.Items.Add("38400")
        cboBaudRate_GS.Items.Add("57600")
        cboBaudRate_GS.Items.Add("115200")
        cboBaudRate_GS.SelectedIndex = 4

        'Data bits combobox
        cboDataBits.Items.Clear()
        cboDataBits.Items.Add("8")
        cboDataBits.SelectedIndex = 0

        cboDataBits_GS.Items.Clear()
        cboDataBits_GS.Items.Add("8")
        cboDataBits_GS.SelectedIndex = 0

        ' Parity combobox
        cboParity.Items.Clear()
        cboParity.Items.Add("None")
        cboParity.Items.Add("Odd")
        cboParity.Items.Add("Even")
        cboParity.SelectedIndex = 0

        cboParity_GS.Items.Clear()
        cboParity_GS.Items.Add("None")
        cboParity_GS.Items.Add("Odd")
        cboParity_GS.Items.Add("Even")
        cboParity_GS.SelectedIndex = 0


        ' Stop bits combobox
        cboStopBits.Items.Clear()
        cboStopBits.Items.Add("1")
        cboStopBits.Items.Add("2")
        cboStopBits.SelectedIndex = 0

        cboStopBits_GS.Items.Clear()
        cboStopBits_GS.Items.Add("1")
        cboStopBits_GS.Items.Add("2")
        cboStopBits_GS.SelectedIndex = 0



        ' Modbus Net ID combobox
        cboMBNetID2.Items.Clear()
        cboMBNetID2.Items.Clear()
        For j As Integer = 1 To 247

            cboMBNetID2.Items.Add(j.ToString())
            cboMBNetID2_GS.Items.Add(j.ToString())
        Next j
        cboMBNetID2.SelectedIndex = 0
        cboMBNetID2_GS.SelectedIndex = 0


        ' Init. the combobox of IR command number
        cboIRCmdNo.Items.Clear()
        cboIRCmdNo2.Items.Clear()
        For i As Integer = 1 To 512
            cboIRCmdNo.Items.Add(i.ToString())
            cboIRCmdNo2.Items.Add(i.ToString())
        Next
        cboIRCmdNo.SelectedIndex = 0
        cboIRCmdNo2.SelectedIndex = 0


        ' Init. the combobox of IR output channel
        cboIROutputCh.Items.Clear()
        For i As Integer = 1 To 6
            cboIROutputCh.Items.Add(i.ToString())
        Next
        cboIROutputCh.Items.Add("1+2+3+4+5+6")
        cboIROutputCh.SelectedIndex = 0

        cboIROutputCh2.Items.Clear()
        cboIROutputCh2.Items.Add("1")
        cboIROutputCh2.Items.Add("2")
        cboIROutputCh2.Items.Add("1 + 2")
        cboIROutputCh2.SelectedIndex = 0


        ' Init. Device name comboboxe
        deviceNameArr(0) = "TV"                          ' IR device #1
        deviceNameArr(1) = "Audio"                       ' IR device #2
        deviceNameArr(2) = "A/C"                         ' IR device #3

        cboDeviceName.Items.Clear()
        For i As Integer = 0 To (deviceNameArr.Length - 1)
            cboDeviceName.Items.Add((i + 1).ToString() + "_" + deviceNameArr(i))
        Next
        cboDeviceName.SelectedIndex = 0


        ' Init. IR command name combobox
        cmdNameArr(0) = "Power Toggle"          ' IR cmd #1
        cmdNameArr(1) = "Vol+"                  ' IR cmd #2
        cmdNameArr(2) = "Vol-"                  ' IR cmd #3
        cmdNameArr(3) = "Power Toggle"          ' IR cmd #4
        cmdNameArr(4) = "Temperature+"          ' IR cmd #5
        cmdNameArr(5) = "Wind Direction"        ' IR cmd #6

        cboIrCmdNameArr.Items.Clear()
        For i As Integer = 0 To (cmdNameArr.Length - 1)
            cboIrCmdNameArr.Items.Add((i + 1).ToString() + "_" + cmdNameArr(i))
        Next
        cboIrCmdNameArr.SelectedIndex = 0


        ' Init. the IR command summary data in the IR Cmd Data buffer in the IR API library.
        Dim rtn As Integer = 0
        Dim moduleIndex As UShort = &H1          ' Module index. 0x01: IR-210
        Dim dataArr(0 To 12) As UShort           ' Array For IR command summary.
        dataArr(0) = 3      ' IR device quantity (#1, #2, #3)
        dataArr(1) = 6      ' Total IR command quantity
        dataArr(2) = 1      ' IR command quantity For IR device #1
        dataArr(3) = 2      ' IR command quantity For IR device #2
        dataArr(4) = 3      ' IR command quantity For IR device #3
        IrCmdSummaryArr(0) = dataArr(0)      ' IR device quantity (#1, #2, #3)
        IrCmdSummaryArr(1) = dataArr(1)      ' Total IR command quantity
        IrCmdSummaryArr(2) = dataArr(2)      ' IR command quantity For IR device #1
        IrCmdSummaryArr(3) = dataArr(3)      ' IR command quantity For IR device #2
        IrCmdSummaryArr(4) = dataArr(4)      ' IR command quantity For IR device #3

        rtn = IR_API_Class.IR_SetIRCmdSummaryBuffer(moduleIndex, dataArr, CType(dataArr.Length, UShort))  ' Set IR cmd summary To buffer.



        ' Init. the IR device name & command name data in the IR Cmd Data buffer in the IR API library.
        Dim IrDevNameArr(0 To 99) As Byte
        Dim IrCmdNameArr(0 To 99) As Byte

        For i As Integer = 0 To (dataArr(0) - 1)

            Select Case i

                Case 0      ' for IR device #1
                    For j As Integer = 0 To (dataArr(2) - 1)

                        Dim IrDevNameArrTemp() As Byte = Encoding.UTF8.GetBytes(deviceNameArr(i))
                        Dim IrCmdNameArrTemp() As Byte = Encoding.UTF8.GetBytes(cmdNameArr(j))
                        rtn = IR_API_Class.IR_SetIrDevCmdNameInBuffer(
                                CType(j + 1, UInt16),
                                IrDevNameArrTemp, CType(IrDevNameArrTemp.Length, UInt16),
                                IrCmdNameArrTemp, CType(IrCmdNameArrTemp.Length, UInt16)
                            )
                    Next

                Case 1      ' for IR device #2
                    For j As Integer = 0 To dataArr(3) - 1

                        Dim IrDevNameArrTemp() As Byte = Encoding.UTF8.GetBytes(deviceNameArr(i))
                        Dim IrCmdNameArrTemp() As Byte = Encoding.UTF8.GetBytes(cmdNameArr(j + dataArr(2)))
                        rtn = IR_API_Class.IR_SetIrDevCmdNameInBuffer(
                                CType(j + dataArr(2) + 1, UInt16),
                                IrDevNameArrTemp, CType(IrDevNameArrTemp.Length, UInt16),
                                IrCmdNameArrTemp, CType(IrCmdNameArrTemp.Length, UInt16)
                            )
                    Next

                Case 2      ' for IR device #3
                    For j As Integer = 0 To dataArr(4) - 1

                        Dim IrDevNameArrTemp() As Byte = Encoding.UTF8.GetBytes(deviceNameArr(i))
                        Dim IrCmdNameArrTemp() As Byte = Encoding.UTF8.GetBytes(cmdNameArr(j + dataArr(2) + dataArr(3)))
                        rtn = IR_API_Class.IR_SetIrDevCmdNameInBuffer(
                                CType(j + dataArr(2) + dataArr(3) + 1, UInt16),
                                IrDevNameArrTemp, CType(IrDevNameArrTemp.Length, UInt16),
                                IrCmdNameArrTemp, CType(IrCmdNameArrTemp.Length, UInt16)
                            )
                    Next

                Case Else

            End Select

        Next


        ' Init rectangle
        Rect1.Fill = New SolidColorBrush(System.Windows.Media.Colors.White)

        txtIRCmdQtyTotal.Text = "6"
        txtDeviceQty.Text = "3"

    End Sub

    Private Sub btnGetAPIVer_Click(sender As Object, e As RoutedEventArgs)
        Dim verValue As UInt32
        Dim major, minor, revision, buildNo As String
        verValue = IR_API_Class.IR_GetAPIVersion()
        major = ((verValue >> 24) And &HFF).ToString()
        minor = ((verValue >> 16) And &HFF).ToString()
        revision = ((verValue >> 8) And &HFF).ToString()
        buildNo = (verValue And &HFF).ToString()

        txtAPIVer.Text = major + "." + minor + "." + revision + "." + buildNo

    End Sub

    Private Sub btnGetAPIDate_Click(sender As Object, e As RoutedEventArgs)
        Dim dateValue As UInt32
        Dim APIDate As String
        dateValue = IR_API_Class.IR_GetAPIDate()
        APIDate = (dateValue >> 16).ToString() + "-" + ((dateValue >> 8) And &HFF).ToString() + "-" + (dateValue And &HFF).ToString()
        txtAPIDate.Text = APIDate
    End Sub

    Private Sub btnGetComPortStatus_Click(sender As Object, e As RoutedEventArgs)
        Dim rtn As Int32
        rtn = IR_API_Class.IR_GetComPortStatus(CType(cboCOMPort.SelectedIndex + 1, Byte))

        If (rtn = IR_API_Class.IR_E_COM_STATUS_AVAIL) Then
            txtGetComPortStatus.Text = "Available"
        Else
            txtGetComPortStatus.Text = "Error"
        End If
    End Sub

    Private Sub btnOpenCOM_Click(sender As Object, e As RoutedEventArgs)

        Dim rtn As Int32

        If (cboCOMPort.SelectedIndex < 0) Then
            MessageBox.Show("No COM Port")
            Return
        End If

        ' Get COM port number
        _comPortNo = CType(cboCOMPort.SelectedIndex + 1, Byte)

        ' Get buad rate
        Select Case cboBaudRate.SelectedIndex

            Case 0     ' 9600 bps
                _baudRate = 9600
                _baudRateIndex = 6
            Case 1     ' 19200 bps
                _baudRate = 19200
                _baudRateIndex = 7
            Case 2     ' 38400 bps
                _baudRate = 38400
                _baudRateIndex = 8
            Case 3     ' 57600 bps
                _baudRate = 57600
                _baudRateIndex = 9
            Case 4     ' 115200 bps
                _baudRate = 115200
                _baudRateIndex = 10
            Case Else
                _baudRate = 115200
                _baudRateIndex = 10
        End Select

        ' Get Data bits
        Select Case cboDataBits.SelectedIndex
            Case 0
                _databits = 8
            Case Else
                _databits = 8
        End Select


        ' Get parity
        Select Case cboParity.SelectedIndex
            Case 0    ' None
                _parity = 0
            Case 1    ' Odd
                _parity = 1
            Case 2    ' Even
                _parity = 2
            Case Else
                _parity = 0
        End Select

        ' Get Stop bits index
        Select Case cboStopBits.SelectedIndex
            Case 0
                _stopbitsIndex = 1   ' Stop bits = 1;
            Case 1
                _stopbitsIndex = 2   ' Stop bits = 2
            Case Else
                _stopbitsIndex = 1
        End Select

        ' Get Modbus Net ID
        _mbID = Byte.Parse(cboMBNetID2.Text)

        rtn = IR_API_Class.IR_OpenCom(_comPortNo, _baudRateIndex, _databits, _parity, _stopbitsIndex)
        txtOpenCOMRtn.Text = rtn.ToString()  ' Show the Return value Of the UartOpenCom(). 

        If (rtn > 0) Then
            ' Error
            MessageBox.Show("Open COM error. Error code = " + rtn.ToString(), "Error")
            btnOpenCOM.IsEnabled = True

        Else
            ' Open COM OK
            btnOpenCOM.IsEnabled = False
        End If

    End Sub

    Private Sub btnCloseCOM_Click(sender As Object, e As RoutedEventArgs)
        Dim rtn As Int32 = IR_API_Class.IR_CloseCom(_comPortNo)
        txtCloseCOMRtn.Text = rtn.ToString()
        btnOpenCOM.IsEnabled = True
    End Sub

    Private Sub btnChkModuleName_Click(sender As Object, e As RoutedEventArgs)
        Dim moduleIndex As UInt16 = 0
        _mbID = Byte.Parse(cboMBNetID2.Text)

        ' Get the module name of the IR module.
        Dim rtn As Int32 = IR_API_Class.IR_ChkModuleName(_comPortNo, _mbID, moduleIndex)
        txtOpenComChkRtn.Text = rtn.ToString()
        If (moduleIndex = &H1) Then
            txtModuleIndex.Text = "IR-210"
        ElseIf (moduleIndex = &H11) Then
            txtModuleIndex.Text = "IR-712A"
        Else
            txtModuleIndex.Text = ""
        End If

    End Sub

    Private Sub btnMRTUGetBasicSettings_Click(sender As Object, e As RoutedEventArgs)
        Dim rtn As Integer = 0
        Dim mRtuBasicSetStruct As IR_API_Class.BasicSetParams

        ' Get basic settings.
        rtn = IR_API_Class.IR_GetBasicSetting(_comPortNo, _mbID, mRtuBasicSetStruct)

        txtGetBasicSet.Text = rtn.ToString()

        If (rtn = IR_API_Class.IR_E_OK) Then
            ' Get baud rate
            Select Case mRtuBasicSetStruct.ucBaudrateIndex
                Case 6    ' 9600 bps
                    cboBaudRate_GS.SelectedIndex = 0
                Case 7    ' 19200 bps
                    cboBaudRate_GS.SelectedIndex = 1
                Case 8    ' 38400 bps
                    cboBaudRate_GS.SelectedIndex = 2
                Case 9    ' 57600 bps
                    cboBaudRate_GS.SelectedIndex = 3
                Case 10    ' 115200 bps
                    cboBaudRate_GS.SelectedIndex = 4
                Case Else
                    cboBaudRate_GS.SelectedIndex = 4
            End Select

            'Get databits
            Select Case mRtuBasicSetStruct.ucData
                Case 8    ' 8 databits
                    cboDataBits_GS.SelectedIndex = 0
                Case Else
                    cboDataBits_GS.SelectedIndex = 0
            End Select


            ' Get Parity
            Select Case mRtuBasicSetStruct.ucParity
                Case 0    ' None
                    cboParity_GS.SelectedIndex = 0
                Case 1    ' Odd
                    cboParity_GS.SelectedIndex = 1
                Case 2    ' Even
                    cboParity_GS.SelectedIndex = 2
                Case Else
                    cboParity_GS.SelectedIndex = 0
            End Select


            ' Get stopbits
            Select Case mRtuBasicSetStruct.ucStop
                Case 1    ' stopbits 1
                    cboStopBits_GS.SelectedIndex = 0
                Case 2    ' stopbits 2
                    cboStopBits_GS.SelectedIndex = 1
                Case Else
                    cboStopBits_GS.SelectedIndex = 0
            End Select


            ' Get Modbus Net ID
            cboMBNetID2_GS.SelectedIndex = mRtuBasicSetStruct.ucNetID - 1


            ' Modbus response delay time (ms)
            txtMBRespDelayTime.Text = mRtuBasicSetStruct.usMBRespDlyT.ToString()

            ' Get Gaptime of IR learning (ms)
            txtGapTime.Text = mRtuBasicSetStruct.usGapTime.ToString()

            MessageBox.Show("Get Basic Settings OK", "OK")
        Else
            MessageBox.Show("Error in IR_GetBasicSetting()", "Fail")
        End If
    End Sub

    Private Sub btnMRTUSetBasicSettings_Click(sender As Object, e As RoutedEventArgs)
        Dim rtn As Integer = 0

        Dim mRtuBasicSetStruct As IR_API_Class.BasicSetParams

        '
        '_comPortNo = (Byte)(cboCOMPort.SelectedIndex + 1);

        ' Set baud rate
        Select Case (cboBaudRate_GS.SelectedIndex)
            Case 0     ' 9600 bps
                _baudRateIndex = 6

            Case 1    ' 19200 bps
                _baudRateIndex = 7

            Case 2    ' 38400 bps
                _baudRateIndex = 8

            Case 3    ' 57600 bps
                _baudRateIndex = 9

            Case 4    ' 115200 bps
                _baudRateIndex = 10

            Case Else
                _baudRateIndex = 10
                '}
        End Select

        ' Get Data bits
        Select Case cboDataBits_GS.SelectedIndex
            Case 0
                _databits = 8

            Case Else
                _databits = 8

        End Select

        ' Get parity
        Select Case cboParity_GS.SelectedIndex
            Case 0    ' None
                _parity = 0

            Case 1    ' Odd
                _parity = 1

            Case 2    ' Even
                _parity = 2

            Case Else
                _parity = 0

        End Select


        ' Get Stip bits index
        Select Case cboStopBits_GS.SelectedIndex
            Case 0   ' stop bits = 1
                _stopbitsIndex = 1

            Case 1   ' stop bits = 2
                _stopbitsIndex = 2

            Case Else
                _stopbitsIndex = 1

        End Select

        ' Get Modbus Net ID
        _mbID = Byte.Parse(cboMBNetID2_GS.Text)

        ' *******************************************************************************************
        mRtuBasicSetStruct.ucBaudrateIndex = _baudRateIndex
        mRtuBasicSetStruct.ucData = _databits                                    ' Databits = 8
        mRtuBasicSetStruct.ucParity = _parity                                    ' Parity = 0 (None)
        mRtuBasicSetStruct.ucStop = _stopbitsIndex                               ' Stpo bits = 0 (=>1) 
        mRtuBasicSetStruct.usGapTime = UInt16.Parse(txtGapTime.Text)             ' GapTime = 150 ms
        mRtuBasicSetStruct.ucNetID = _mbID                                       ' MB Net ID = 1       
        mRtuBasicSetStruct.usMBRespDlyT = UInt16.Parse(txtMBRespDelayTime.Text)  ' Modbus repsonse delay time = 3 ms
        'Send Basic Settings to IR module.
        rtn = IR_API_Class.IR_SetBasicSetting(_comPortNo, cboMBNetID2.SelectedIndex + 1, mRtuBasicSetStruct)

        txtSetBasicSet.Text = rtn.ToString()

        If (rtn = IR_API_Class.IR_E_OK) Then
            MessageBox.Show("Set OK!" + vbCrLf + "Please close COM, select new settings, " + vbCrLf + " and open COM in new Settings!!!", "OK")
        Else
            MessageBox.Show("Set error", "Error")
        End If
    End Sub

    Private Sub txtBasicSettingDefault_Click(sender As Object, e As RoutedEventArgs)
        cboBaudRate_GS.SelectedIndex = 4
        cboParity_GS.SelectedIndex = 0
        cboDataBits_GS.SelectedIndex = 0
        cboStopBits_GS.SelectedIndex = 0
        cboMBNetID2_GS.SelectedIndex = 0
        txtMBRespDelayTime.Text = "3"
        txtGapTime.Text = "80"
    End Sub

    Private Sub btnResetModule_Click(sender As Object, e As RoutedEventArgs)
        Dim rtn As Integer = 0
        rtn = IR_API_Class.IR_ResetIRModule(_comPortNo)

        Select Case rtn
            Case IR_API_Class.IR_E_RESET_OK
                txtResetModuleRtn.Text = "Reset communication settings to default temporarily."
            Case IR_API_Class.IR_E_RESET_COM_ERR
                txtResetModuleRtn.Text = "COM Error."
            Case IR_API_Class.IR_E_RESET_MODULE_FAIL
                txtResetModuleRtn.Text = "Reset Failed."
            Case Else
        End Select

    End Sub

    Private Sub btnGetIRCmdSummaryBuff_Click(sender As Object, e As RoutedEventArgs)
        Dim rtn As Integer = 0
        'Dim i As Integer
        Dim moduleIndex As UShort = &H1    ' 0x01: IR-210
        ' Module index:
        ' 0x01 => IR-210
        ' 0x11 => IR-712A
        ' 0x21 => IR-712-MTCP
        Dim dataArr(12) As UInt16   ' 13 elements
        Dim dataStr As String = String.Empty

        rtn = IR_API_Class.IR_GetIRCmdSummaryBuffer(moduleIndex, dataArr, dataArr.Length)

        ' Show the IR command summary.
        For i As Integer = 0 To (dataArr.Length - 1)

            If (i = (dataArr.Length - 1)) Then
                dataStr += dataArr(i).ToString()
                'dataStr += (dataArr(i).ToString("X4"))
            Else
                dataStr += (dataArr(i).ToString() + "-")
                'dataStr += (dataArr(i).ToString("X4") + "-")
            End If

            IrCmdSummaryArr(i) = dataArr(i)

        Next

        txtDeviceQty_G.Text = dataArr(0).ToString()
        IrDeviceTotalQty = dataArr(0)
        txtIRCmdQtyTotal_G.Text = dataArr(1).ToString()
        IrCmdCurrTotalCmd = dataArr(1)
        txtIRCmdQtyDevice1_G.Text = dataArr(2).ToString()
        txtIRCmdQtyDevice2_G.Text = dataArr(3).ToString()
        txtIRCmdQtyDevice3_G.Text = dataArr(4).ToString()
        txtIRCmdQtyDevice4_G.Text = dataArr(5).ToString()
        txtIRCmdQtyDevice5_G.Text = dataArr(6).ToString()
        txtIRCmdQtyDevice6_G.Text = dataArr(7).ToString()
        txtIRCmdQtyDevice7_G.Text = dataArr(8).ToString()
        txtIRCmdQtyDevice8_G.Text = dataArr(9).ToString()
        txtIRCmdQtyDevice9_G.Text = dataArr(10).ToString()
        txtIRCmdQtyDevice10_G.Text = dataArr(11).ToString()
        txtIRCmdQtyDevice11_G.Text = dataArr(12).ToString()

        MessageBox.Show(dataStr, "Get dataArr")
    End Sub

    Private Sub btnSetIRCmdSummaryBuff_Click(sender As Object, e As RoutedEventArgs)
        Dim rtn As Integer = 0
        Dim moduleIndex As UInt16 = &H1    ' 0x01: IR-210
        ' Module index:
        ' 0x01 => IR-210
        ' 0x11 => IR-712A
        ' 0x21 => IR-712-MTCP
        Dim dataArr(12) As UInt16   ' 13 elements
        Dim dataStr As String = String.Empty

        dataArr(0) = UInt16.Parse(txtDeviceQty.Text)
        IrDeviceTotalQty = dataArr(0)
        dataArr(1) = UInt16.Parse(txtIRCmdQtyTotal.Text)
        IrCmdCurrTotalCmd = dataArr(1)
        dataArr(2) = UInt16.Parse(txtIRCmdQtyDevice1.Text)
        dataArr(3) = UInt16.Parse(txtIRCmdQtyDevice2.Text)
        dataArr(4) = UInt16.Parse(txtIRCmdQtyDevice3.Text)
        dataArr(5) = UInt16.Parse(txtIRCmdQtyDevice4.Text)
        dataArr(6) = UInt16.Parse(txtIRCmdQtyDevice5.Text)
        dataArr(7) = UInt16.Parse(txtIRCmdQtyDevice6.Text)
        dataArr(8) = UInt16.Parse(txtIRCmdQtyDevice7.Text)
        dataArr(9) = UInt16.Parse(txtIRCmdQtyDevice8.Text)
        dataArr(10) = UInt16.Parse(txtIRCmdQtyDevice9.Text)
        dataArr(11) = UInt16.Parse(txtIRCmdQtyDevice10.Text)
        dataArr(12) = UInt16.Parse(txtIRCmdQtyDevice11.Text)


        rtn = IR_API_Class.IR_SetIRCmdSummaryBuffer(moduleIndex, dataArr, dataArr.Length)

        For i As Integer = 0 To dataArr.Length - 1
            dataStr += (dataArr(i).ToString("X4") + " ")
            IrCmdSummaryArr(i) = dataArr(i)
        Next

        MessageBox.Show(dataStr, "Set IR Cmd Summary to the library buffer.")
    End Sub

    Private Sub btnGetIrDevCmdNameInBuffer_Click(sender As Object, e As RoutedEventArgs)
        ' Note: The IR learning data buffer of the API library was initilized 
        '       with 3 IR device names And 6 IR command names by IR_SetIrDevCmdNameInBuffer()  
        '       in the Window_Loaded() event handler.

        Dim rtn As Integer = 0
        Dim IrDevNameArr(99) As Byte    ' 100 elements
        Dim IrCmdNameArr(99) As Byte    ' 100 elements
        Dim IrDevNameLength As UInt16 = 0
        Dim IrCmdNameLength As UInt16 = 0

        rtn = IR_API_Class.IR_GetIrDevCmdNameInBuffer(CType(cboIRCmdNo2.SelectedIndex + 1, UInt16), IrDevNameArr, CType(IrDevNameArr.Length, UInt16), IrDevNameLength,
                IrCmdNameArr, CType(IrCmdNameArr.Length, UInt16), IrCmdNameLength)

        txtIRDevNameGet.Text = Encoding.UTF8.GetString(IrDevNameArr, 0, IrDevNameLength)
        txtIRCmdNameGet.Text = Encoding.UTF8.GetString(IrCmdNameArr, 0, IrCmdNameLength)

    End Sub

    Private Sub btnSetIrDevCmdNameInBuffer_Click(sender As Object, e As RoutedEventArgs)
        Dim rtn As Integer = 0
        Dim IrDevNameArrTemp() As Byte = Encoding.UTF8.GetBytes(txtIRDevNameSet.Text)
        Dim IrCmdNameArrTemp() As Byte = Encoding.UTF8.GetBytes(txtIRCmdNameSet.Text)

        rtn = IR_API_Class.IR_SetIrDevCmdNameInBuffer(
            CType(cboIRCmdNo2.SelectedIndex + 1, UInt16),
            IrDevNameArrTemp,
            CType(IrDevNameArrTemp.Length, UInt16),
            IrCmdNameArrTemp,
            CType(IrCmdNameArrTemp.Length, UInt16)
            )
    End Sub

    Private Sub txtIRCmdQtyDevice1_TextChanged(sender As Object, e As TextChangedEventArgs)

        Dim irCmdOtyTotal As Integer = 0
        Dim irCmdQtyDevice As Integer = 0
        Dim irDeviceQtyTotal As Integer = 0

        ' #1 device - IR cmd qty
        If (txtIRCmdQtyDevice1 Is Nothing) OrElse (Int16.TryParse(txtIRCmdQtyDevice1.Text, irCmdQtyDevice) = False) Then
            'If (txtIRCmdQtyDevice1 Is Nothing) Then
            irCmdQtyDevice = 0
        End If
        irCmdOtyTotal += irCmdQtyDevice
        'irDeviceQtyTotal += (irCmdQtyDevice > 0 ? 1 : 0)
        irDeviceQtyTotal += If(irCmdQtyDevice > 0, 1, 0)   'conditional ternary operator

        ' #2 device - IR cmd qty
        If (txtIRCmdQtyDevice2 Is Nothing) OrElse (Int16.TryParse(txtIRCmdQtyDevice2.Text, irCmdQtyDevice) = False) Then
            'If (txtIRCmdQtyDevice2 Is Nothing) Or (Int16.TryParse(txtIRCmdQtyDevice2.Text, irCmdQtyDevice) = False) Then
            irCmdQtyDevice = 0
        End If
        irCmdOtyTotal += irCmdQtyDevice
        irDeviceQtyTotal += If(irCmdQtyDevice > 0, 1, 0)   'Conditional ternary operator

        ' #3 device - IR cmd qty
        If (txtIRCmdQtyDevice3 Is Nothing) OrElse (Int16.TryParse(txtIRCmdQtyDevice3.Text, irCmdQtyDevice) = False) Then
            irCmdQtyDevice = 0
        End If
        irCmdOtyTotal += irCmdQtyDevice
        irDeviceQtyTotal += If(irCmdQtyDevice > 0, 1, 0)   'Conditional ternary operator

        ' #4 device - IR cmd qty
        If (txtIRCmdQtyDevice4 Is Nothing) OrElse (Int16.TryParse(txtIRCmdQtyDevice4.Text, irCmdQtyDevice) = False) Then
            irCmdQtyDevice = 0
        End If
        irCmdOtyTotal += irCmdQtyDevice
        irDeviceQtyTotal += If(irCmdQtyDevice > 0, 1, 0)   'Conditional ternary operator

        ' #5 device - IR cmd qty
        If (txtIRCmdQtyDevice5 Is Nothing) OrElse (Int16.TryParse(txtIRCmdQtyDevice5.Text, irCmdQtyDevice) = False) Then
            irCmdQtyDevice = 0
        End If
        irCmdOtyTotal += irCmdQtyDevice
        irDeviceQtyTotal += If(irCmdQtyDevice > 0, 1, 0)   'Conditional ternary operator

        ' #6 device - IR cmd qty
        If (txtIRCmdQtyDevice6 Is Nothing) OrElse (Int16.TryParse(txtIRCmdQtyDevice6.Text, irCmdQtyDevice) = False) Then
            irCmdQtyDevice = 0
        End If
        irCmdOtyTotal += irCmdQtyDevice
        irDeviceQtyTotal += If(irCmdQtyDevice > 0, 1, 0)   'Conditional ternary operator

        ' #7 device - IR cmd qty
        If (txtIRCmdQtyDevice7 Is Nothing) OrElse (Int16.TryParse(txtIRCmdQtyDevice7.Text, irCmdQtyDevice) = False) Then
            irCmdQtyDevice = 0
        End If
        irCmdOtyTotal += irCmdQtyDevice
        irDeviceQtyTotal += If(irCmdQtyDevice > 0, 1, 0)   'Conditional ternary operator

        ' #8 device - IR cmd qty
        If (txtIRCmdQtyDevice8 Is Nothing) OrElse (Int16.TryParse(txtIRCmdQtyDevice8.Text, irCmdQtyDevice) = False) Then
            irCmdQtyDevice = 0
        End If
        irCmdOtyTotal += irCmdQtyDevice
        irDeviceQtyTotal += If(irCmdQtyDevice > 0, 1, 0)   'Conditional ternary operator

        ' #9 device - IR cmd qty
        If (txtIRCmdQtyDevice9 Is Nothing) OrElse (Int16.TryParse(txtIRCmdQtyDevice9.Text, irCmdQtyDevice) = False) Then
            irCmdQtyDevice = 0
        End If
        irCmdOtyTotal += irCmdQtyDevice
        irDeviceQtyTotal += If(irCmdQtyDevice > 0, 1, 0)   'Conditional ternary operator

        ' #10 device - IR cmd qty
        If (txtIRCmdQtyDevice10 Is Nothing) OrElse (Int16.TryParse(txtIRCmdQtyDevice10.Text, irCmdQtyDevice) = False) Then
            irCmdQtyDevice = 0
        End If
        irCmdOtyTotal += irCmdQtyDevice
        irDeviceQtyTotal += If(irCmdQtyDevice > 0, 1, 0)   'Conditional ternary operator

        ' #11 device - IR cmd qty
        If (txtIRCmdQtyDevice11 Is Nothing) OrElse (Int16.TryParse(txtIRCmdQtyDevice11.Text, irCmdQtyDevice) = False) Then
            irCmdQtyDevice = 0
        End If
        irCmdOtyTotal += irCmdQtyDevice
        irDeviceQtyTotal += If(irCmdQtyDevice > 0, 1, 0)   'Conditional ternary operator

        txtIRCmdQtyTotal.Text = irCmdOtyTotal.ToString()
        txtDeviceQty.Text = irDeviceQtyTotal.ToString()

    End Sub

    Private Sub btnRefreshIRDevCmdNameInLibBuf_Click(sender As Object, e As RoutedEventArgs)
        Dim rtn As Integer = 0
        Dim IrDevNameArr(99) As Byte    ' array with 100 elements
        Dim IrCmdNameArr(99) As Byte    ' array with 100 elements
        Dim IrDevNameLength As UInt16 = 0
        Dim IrCmdNameLength As UInt16 = 0
        Dim irCmdNo As UInt16 = 0

        btnGetIRCmdSummaryBuff_Click(sender, e)     ' Get IR cmd summary from the IR library buffer.

        cboDeviceName.Items.Clear()
        cboIrCmdNameArr.Items.Clear()

        ' Initialize the items of IR device names & IR cmd name (comments) comboboxes.  
        For i As Integer = 0 To (IrCmdSummaryArr(0) - 1)
            For j As Integer = 0 To (IrCmdSummaryArr(i + 2) - 1)
                irCmdNo = irCmdNo + 1
                rtn = IR_API_Class.IR_GetIrDevCmdNameInBuffer(irCmdNo, IrDevNameArr, CType(IrDevNameArr.Length, UInt16), IrDevNameLength,
                        IrCmdNameArr, CType(IrCmdNameArr.Length, UInt16), IrCmdNameLength)

                cboIrCmdNameArr.Items.Add(irCmdNo.ToString() + "_" + Encoding.UTF8.GetString(IrCmdNameArr, 0, IrCmdNameLength))
            Next

            cboDeviceName.Items.Add((i + 1).ToString() + "_" + Encoding.UTF8.GetString(IrDevNameArr, 0, IrDevNameLength))
        Next

        If ((cboDeviceName.Items.Count <> 0) And (cboIrCmdNameArr.Items.Count <> 0)) Then
            cboDeviceName.SelectedIndex = 0
            cboIrCmdNameArr.SelectedIndex = 0
        End If
    End Sub

    Private Sub btnMRtuLrnON_Click(sender As Object, e As RoutedEventArgs) Handles btnMRtuLrnON.Click
        Dim rtn As Integer = IR_API_Class.IR_LrnModeSet(_comPortNo, _mbID, 1)

        If (rtn <> IR_API_Class.IR_E_OK) Then
            MessageBox.Show("IR-Learn-ON failed", "Error")
        End If
    End Sub

    Private Sub btnIsLearnOK_Click(sender As Object, e As RoutedEventArgs)
        Dim isLearnOK As UInt16 = 0   ' Variable to indicate if learning an IR cmd Is completed. 0=>Not yet. 1=>completed.
        Dim rtn As Integer = IR_API_Class.IR_IsIRLearnOK(_comPortNo, isLearnOK, UInt16.Parse(txtRecvTout.Text))
        txtIsLrnOKRtn.Text = rtn.ToString()
        MessageBox.Show("Is IR-Learning OK? => " + If(isLearnOK = 1, "OK", "Not OK"), "Is IR learning OK?")
    End Sub

    Private Sub btnMRtuLrnOFF_Click(sender As Object, e As RoutedEventArgs) Handles btnMRtuLrnOFF.Click
        Dim rtn As Integer = IR_API_Class.IR_LrnModeSet(_comPortNo, _mbID, 0)

        If (rtn <> IR_API_Class.IR_E_OK) Then
            MessageBox.Show("IR-Learn-OFF failed", "Error")
        End If
    End Sub

    Private Sub btnGetIRCmdAfterLrn_Click(sender As Object, e As RoutedEventArgs)
        Dim cboCurrSelectedIndex As Integer = cboIrCmdNameArr.SelectedIndex
        Dim rtn As Integer = IR_API_Class.IR_GetIRCmdAfterLearn(_comPortNo, _mbID, CType(cboCurrSelectedIndex + 1, UInt16))

        If (rtn = IR_API_Class.IR_E_OK) Then
            cboIrCmdNameArr_DropDownClosed(sender, e)
            MessageBox.Show("Call IR_GetIRCmdAfterLearn() OK.", "OK")
        Else
            MessageBox.Show("Error in calling IR_GetIRCmdAfterLearn()", "Error")
        End If
    End Sub

    Private Sub btnRunCmd_Click(sender As Object, e As RoutedEventArgs)
        Dim rtn As Integer = IR_API_Class.IR_RunCommand(_comPortNo, _mbID, CType(cboIrCmdNameArr.SelectedIndex + 1, UInt16), IROutputChArr(cboIROutputCh.SelectedIndex))

        If (rtn <> IR_API_Class.IR_E_OK) Then
            MessageBox.Show("Error in calling IR_RunCommand()", "Error")
        End If
    End Sub

    Private Sub btnClearOneIRDataInLib_Click(sender As Object, e As RoutedEventArgs)
        Dim moduleIndex As UInt16 = &H1   ' IR-210
        Dim cboIndex As Integer = cboIrCmdNameArr.SelectedIndex
        Dim rtn As Integer = IR_API_Class.IR_ClearOneIRLrnDataInAPI(CType(cboIndex + 1, UInt16), moduleIndex)

        If (rtn <> IR_API_Class.IR_E_OK) Then
            MessageBox.Show("IR_ClearOneIRLrnDataInAPI() return error code = " + rtn.ToString(), "IR_ClearOneIRLrnDataInAPI Error")
        End If

        cboIrCmdNameArr_DropDownClosed(sender, e)
    End Sub

    Private Sub cboIrCmdNameArr_DropDownClosed(sender As Object, e As EventArgs)
        Dim rtn As Integer = 0
        rtn = IR_API_Class.IR_ChkIrDataExistInBuffer(CType(cboIrCmdNameArr.SelectedIndex + 1, UInt16))


        If (rtn = IR_API_Class.IR_E_IRCMD_DATA_EXIST) Then
            Rect1.Fill = New SolidColorBrush(System.Windows.Media.Colors.Red)
        Else
            Rect1.Fill = New SolidColorBrush(System.Windows.Media.Colors.White)
        End If
    End Sub

    Private Sub btnSetIRCmdSummary_Click(sender As Object, e As RoutedEventArgs)
        Dim rtn As Integer = 0
        Dim moduleIndex As UInt16 = &H1   '0x01: ModuleIndex of IR-210
        Dim dataArr(0 To 12) As UInt16

        Dim msgRst As MessageBoxResult = MessageBox.Show(
            "Before pressing this button, press the ""btnSetIRCmdSummaryBuff"" button in advance in group Step 4 to update the IR cmd summary if necessary. " + vbCrLf + "This button will write the IR command summary in the library buffer" + vbCrLf + "to the flash memory of the IR module." + vbCrLf + "Are you sure to proceed?\n",
            "Warning",
            MessageBoxButton.YesNo,
            MessageBoxImage.Warning)

        If (msgRst = MessageBoxResult.No) Then
            Return
        End If

        btnSetIRCmdSummaryBuff_Click(sender, e)

        rtn = IR_API_Class.IR_SetIRCmdSummary(_comPortNo, _mbID, moduleIndex)

        txtSetIRCmdSummaryRtn.Text = rtn.ToString()


    End Sub

    Private Sub Update_txtIRCmdQtyCurr()
        txtIRCmdQtyCurr.Text = (ii + 1).ToString()
    End Sub

    Private Sub DownloadIRProcess()
        Dim rtn As Integer = 0
        For ii = 0 To (IrCmdCurrTotalCmd - 1)
            rtn = IR_API_Class.IR_DLOneIRDataToModule(_comPortNo, _mbID, CType(ii + 1, UInt16))

            If (rtn <> IR_API_Class.IR_E_OK) Then
                MessageBox.Show("Failed to download IR cmds", "Download Error")
                Return
            End If

            Dispatcher.BeginInvoke(Sub() Update_txtIRCmdQtyCurr())

            Thread.Sleep(50)
        Next

        MessageBox.Show("Download " + IrCmdCurrTotalCmd.ToString() + " IR cmds to the IR modules successfully.", "Download OK")
    End Sub

    Private Sub btnDLOneIRDataToModule_Click(sender As Object, e As RoutedEventArgs)
        thDwLDIR = New Thread(New ThreadStart(AddressOf DownloadIRProcess))
        thDwLDIR.Start()
    End Sub

    Private Sub btnEmitIRCmd_Click(sender As Object, e As RoutedEventArgs)
        Dim rtn As Integer = IR_API_Class.IR_EmitIrSignal(_comPortNo, _mbID, CType(cboIRCmdNo.SelectedIndex + 1, UInt16), IROutputChArr(cboIROutputCh2.SelectedIndex))
    End Sub

    Private Sub btnGetIRCmdSummary_Click(sender As Object, e As RoutedEventArgs)
        Dim rtn As Integer = 0
        Dim moduleIndex As Integer = &H1   ' 0x01: ModuleIndex of IR-210
        Dim dataArr(0 To 12) As UInt16
        Dim dataStr As String = String.Empty

        rtn = IR_API_Class.IR_GetIRCmdSummary(_comPortNo, _mbID, moduleIndex, dataArr, CType(dataArr.Length, UInt16))
        txtGetIRCmdSummaryRtn.Text = rtn.ToString()

        If (rtn = IR_API_Class.IR_E_OK) Then
            ' Show the IR command summary.
            For i As Integer = 0 To (dataArr.Length - 1)
                If (i = (dataArr.Length - 1)) Then
                    dataStr += (dataArr(i).ToString())
                Else
                    dataStr += (dataArr(i).ToString() + "-")
                End If

                IrCmdSummaryArr(i) = dataArr(i)
            Next

            txtGetIRCmdSummary.Text = dataStr

            IrDeviceTotalQty = dataArr(0)
            IrCmdCurrTotalCmd = dataArr(1)

            MessageBox.Show("Get IR Cmd Summary OK!", "Success")

        Else
            MessageBox.Show("Failed to Get IR Cmd Summary!", "Error")
        End If
    End Sub

    Private Sub LoadIRProcess()

        Dim rtn As Integer = 0
        'Dim i As Integer = 0
        For ii = 0 To (IrCmdCurrTotalCmd - 1)
            rtn = IR_API_Class.IR_LDOneIRDataToAPI(_comPortNo, _mbID, CType(ii + 1, UInt16))

            If (rtn <> IR_API_Class.IR_E_OK) Then
                MessageBox.Show("Failed to load IR cmds", "load Error")
                Return
            End If

            Dispatcher.BeginInvoke(Sub() Update_txtIRCmdQtyCurr())
            Thread.Sleep(50)
        Next

        MessageBox.Show("Load " + IrCmdCurrTotalCmd.ToString() + " IR cmds back to the IR API library successfully.", "Load back OK")

    End Sub

    Private Sub btnLDOneIRDataToAPI_Click(sender As Object, e As RoutedEventArgs)
        thLDIR = New Thread(New ThreadStart(AddressOf LoadIRProcess))
        thLDIR.Start()
    End Sub

    Private Sub cboDeviceName_DropDownClosed(sender As Object, e As EventArgs)
        Dim cbo As ComboBox = sender
        Dim index As Integer = 0
        For i As Integer = 0 To (cbo.SelectedIndex - 1)
            index += IrCmdSummaryArr(i + 2)
        Next
        cboIrCmdNameArr.SelectedIndex = index   ' Show the first IR cmd name For the IR device #.
    End Sub

    Private Sub cboIrCmdNameArr_SelectionChanged(sender As Object, e As SelectionChangedEventArgs)
        Dim rtn As Integer = 0
        rtn = IR_API_Class.IR_ChkIrDataExistInBuffer(CType(cboIrCmdNameArr.SelectedIndex + 1, UInt16))

        If (rtn = IR_API_Class.IR_E_IRCMD_DATA_EXIST) Then
            Rect1.Fill = New SolidColorBrush(System.Windows.Media.Colors.Red)
        Else
            Rect1.Fill = New SolidColorBrush(System.Windows.Media.Colors.White)
        End If
    End Sub

    Private Sub btnSaveIRCmdToFile_Click(sender As Object, e As RoutedEventArgs)
        Dim rtn As Integer = IR_API_Class.IR_SaveIRCmdsToFile(txtFilePath_Save.Text)
        txtSaveIRCmdToFileRtn.Text = rtn.ToString()

        If (rtn <> IR_API_Class.IR_E_OK) Then
            MessageBox.Show("Save failed.")
        End If
    End Sub

    Private Sub btnLoadIRCmdToFile_Click(sender As Object, e As RoutedEventArgs)
        Dim rtn As Integer = IR_API_Class.IR_LoadIRCmdsFromFile(txtFilePath_Load.Text)
        txtLoadIRCmdToFileRtn.Text = rtn.ToString()

        If (rtn <> IR_API_Class.IR_E_OK) Then
            MessageBox.Show("Load failed.")
        End If
    End Sub

    Private Sub btnGetMBRecvTOut_Click(sender As Object, e As RoutedEventArgs)
        Dim rtn As Integer = IR_API_Class.IR_GetModbusRecvTimeout()
        txtRecvTout1.Text = rtn.ToString()
    End Sub

    Private Sub btnSetMBRecvTOut_Click(sender As Object, e As RoutedEventArgs)
        IR_API_Class.IR_SetModbusRecvTimeout(CType(Integer.Parse(txtRecvTout1.Text), UInt16))
    End Sub

End Class
